// Squeeze Bottle Code modified to work with the Arduino Leonardo Board type

// Libraries used in the code
#include <elapsedMillis.h>
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BMP280.h>

elapsedMillis timeElapsed; 

// Pressure variables
int dpMax = 10000;
float pp = 0;

int Value1[] = {0,0,0,0,0,0,0,0,0,0};

// Start the Adafruit BMP280 i2c Temp+Pressure Sensing Board
Adafruit_BMP280 bme;

// The Setup code which is run once when the microcontroller is turned on
void setup() {  
  if (!bme.begin()) {  
    while (1);
  }
  // Take an average reading to get the initial value
  for (int i = 0; i < 100; i++) {
    pp = pp + bme.readPressure();
    delay(10);
  }
  pp = pp/100;
}

// The main loop which runs repeatedly after the setup code is finished
void loop() {
    if(timeElapsed>10){
      for(int n = 0; n < 9; n++){
        Value1[n] = Value1[n+1];
      }
      Value1[9] = map(bme.readPressure()-pp, 0, dpMax, 0, 110);
      timeElapsed = 0;     
    }
    printOutput();
}

void printOutput(){
  for(int n = 0; n< 10; n++){
    Serial.print(Value1[n], DEC); 
    if(n!=9){
      Serial.print(",");      
    }
  }
  Serial.println();
  delay(1);  
}


